(function (win, doc) {

var
	cfg,
	rgxIsSVG = /svgz?$/i,
	oex = opera['extension'],
	root = doc.documentElement,
	img = doc.querySelector('html:root>body img[src=""]'),
	isRaster = (img || {src: null}).src == win.location.href,
	isSVG = !isRaster && (doc instanceof win['SVGDocument'] || (root && root.nodeName.indexOf('svg') === 0) || rgxIsSVG.test(win.location.pathname));

if (isSVG && win.location.hash.indexOf('#IMAGUS_SVG') > -1) {
	if (win.location.hash.indexOf('#IMAGUS_SVG_GET') > -1) {
		var i = 10, wh, isSVG,
		sendDimensions = function () {
			if (!doc.documentElement) { return; }
			doc.documentElement.suspendRedraw && doc.documentElement.suspendRedraw(10000);
			if (isSVG = doc.documentElement.nodeName.indexOf('svg') === 0) {
				wh = {'w': parseInt(doc.documentElement.getAttribute('width'), 10), 'h': parseInt(doc.documentElement.getAttribute('height'), 10)};

				if (!wh['w'] || !wh['h']) {
					wh = doc.documentElement['getBBox']();
					if (!(!isNaN(parseFloat(wh.width)) && isFinite(wh.width))) { return; }
					wh = {'w': wh.width, 'h': wh.height};
				}
			}

			clearInterval(interv);
			oex.postMessage({'cmd': 'svg_info', 'svg': isSVG, 'url': win.location.href, 'wh': wh});
		},
		interv = setTimeout(function () { sendDimensions(); if (--i) { clearInterval(interv); return; } }, 500);

		doc.documentElement && sendDimensions();
	}

	return;
}

if (isRaster/* || (doc instanceof win['SVGDocument'] && doc.URL == win.top.location.href)*/) {
	oex.addEventListener('message', function (e) {
		if (!e.data['hello']) { return; }

		cfg = e.data['prefs'];
		var prefs = e.data['prefs']['viewer'];

		if (prefs.dam === 4) { return; }

		img.naturalWidth = 0;
		img.error = true;

		if (prefs.dam === 5) {
			doc.body.style.padding = '0';
			img.onclick = win.onkeypress = win.onmousedown = win.onmouseup = win.onmousemove = null;
			return;
		}

	//if (isRaster) {
		document['head'].innerHTML = '';
		doc.body.innerHTML = '';

		img = new Image();

		img.onerror = function() {
			img = {error: true};
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff;font-family:Verdana">' + LN('IMG_FAILED') + '</h2>';
		};

		if (PVI) {
			if (prefs['detectLarger']) {
				PVI.after_init(e);
				PVI.target = {src: win.location.href, currentStyle: {backgroundImage: 'none'}};
				PVI = PVI.find();
				if (PVI && prefs['detectLarger'] === 1 && !win.confirm(LN('IMG_LARGERAVAIL') + '\n')) { PVI = null; }
			}
			else { PVI = null; }

			if (PVI) { try {win.history.pushState(null, null, PVI);} catch (ex) {} }
		}

		img.src = typeof PVI == 'string' ? PVI : win.location.href;

		if (img.src.indexOf('data:') === 0) {
			img.alt = 'Image (inline)';
			doc.title = 'Image';
		}
		else {
			img.alt = (win.location.pathname.match(/(?:[^\/]+)?$/)[0] + win.location.search) || 'Image';
		}

		if (img.naturalWidth === 0) {
			doc.body.innerHTML = '<h2 style="padding-top:100px;text-align:center;text-shadow:1px 1px 10px #000;color:#fff;font-family:Verdana">' + img.alt + '</h2>';
			doc.body.firstElementChild.onclick = function () { this.parentNode.appendChild(img); this.parentNode.removeChild(this); };
		}
	/*}
	else {
		return;
		var img = '';
	}*/

		if (img.error) { return; }

		var sX, sY,
		noFit = {cur: false, real: false},
		progress = null,
		cancelAction = false,
		fZoom = null,
		pixelThresHold = prefs.pixelmove,
		dragScroll = [],
		borderSize = 0,
		init = {loop: 0, wait: 300, maxLoop: 1000},
		MAXSIZE = 0x7fff, // maybe it should remove, because of Opera 12
		nodeStyle = 'width:100%;height:100%;',
		docStyle = 'body{margin:0;font:12px Verdana,"DejaVu Sans"}.m_1{max-width:100%;max-height:100%;width:auto;height:auto}.m_2{width:100%;height:auto}.m_3{height:100%;width:auto}';

		root || (root = doc.documentElement);

		if (!/^[ts]:/.test(prefs.imgInfo) || prefs.imgInfo == '%url') {
			prefs.imgInfo = false;
		}
/*		else if (prefs.imgInfo[0] == 's') {
			doc.addEventListener('mouseover', img.imgInfo, false);
			doc.addEventListener('mouseup', img.imgInfo, false);
		}*/

		document.body.style.cssText = nodeStyle;

		// scrollbars
		if (prefs.hideSB) {
			nodeStyle += 'overflow:hidden;';
		}

		// background
		if (!!prefs.backg) {
			if (prefs.backg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/(?:http|-o-skin)/i.test(prefs.backg)) { nodeStyle += 'background-image:' + prefs.backg + ';'; }
			else { nodeStyle += 'background-color:' + prefs.backg + ';'; }
		}

		if (nodeStyle !== '') {
			root.style.cssText = nodeStyle;
		}

		nodeStyle = '';

		// image background
		if (!!prefs.imgBg) {
			if (prefs.imgBg == 'cb') {
				nodeStyle += 'background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7);';
			}
			else if (/(?:http|-o-skin)/i.test(prefs.imgBg)) { nodeStyle += 'background-image:' + prefs.imgBg + ';'; }
			else { nodeStyle += 'background-color:' + prefs.imgBg + ';'; }
		}

		if (!!prefs.imgBorder) {
			nodeStyle += 'border:' + (img.style.border = prefs.imgBorder) + ';';
			borderSize = parseInt(prefs.imgBorder, 10);

			if (borderSize > 100) {
				borderSize = 100;
				nodeStyle += 'border-width:' + borderSize + 'px !important;';
			}

			nodeStyle += 'background-clip:padding-box;box-sizing:border-box;';
		}

		docStyle += 'img{position:absolute;' + nodeStyle + '}';

		var load = function(noneedinterval) {
			if (img.error) {
				if (progress) { clearInterval(progress); }
				return;
			}

			if (img.width > 0 || noneedinterval) {
				clearInterval(progress);
				progress = null;

				if (!img.naturalWidth) {
					img.naturalWidth = img.width;
					img.naturalHeight = img.height;
				}

				document['head'].innerHTML = '<style>' + docStyle + 'body>img{max-width:' + Math.min(MAXSIZE, Math.floor(img.naturalWidth * MAXSIZE / img.naturalHeight)) + 'px;max-height:' + Math.min(MAXSIZE, Math.floor(img.naturalHeight * MAXSIZE / img.naturalWidth)) + 'px}' + '</style>';

				doc.body.innerHTML = '';
				doc.body.appendChild(img);

				// Opera does not support images larger than ??MP
				/*if (img.naturalWidth * img.naturalHeight > 100 * 10E6) {
					doc.body.innerHTML = '<h2>' + LN('IMG_TOO_LARGE') + '</h2>';
					return;
				}*/

				img.resize = function(m, w, h) {
					if (m === 4) {
						prefs.dam = 4;
						this.style.display = 'none';
						this.parentNode.style.backgroundImage = 'url("'+this.src+'")';
						this.setPos();
						return;
					}
					else if (prefs.dam === 4) {
						this.style.display = 'run-in';
						this.parentNode.style.backgroundImage = '';
					}
					else if (m === -1 || (m === -1 && fZoom)) {
						this.style.width = w;
						h && (this.style.height = h);

						if ((w == '' || w === this.naturalWidth) && (h == '' || h === this.naturalHeight)) {
							m = 0;
						}
					}

					if (m !== -1 && prefs.dam === -1) {
						this.style.width = this.style.height = '';
					}

					this.className !== 'm_' + m && (this.className = 'm_' + m);

					prefs.dam = m;

					if (this.naturalWidth && this.naturalHeight && this.calcFit) {
						this.setPos();
						this.calcFit();
						this.hScroll();
						this.setCur();
						this.setInfo();
					}
				};

				img.setInfo = function() {
					if (!prefs.imgInfo || !(img.naturalWidth && img.naturalHeight)) { return; }

					var info = prefs.imgInfo.replace('%w', img.width).replace('%h', img.height).replace('%ow', img.naturalWidth).replace('%oh', img.naturalHeight).replace('%url', win.location).replace('%name', img.alt);

					if (prefs.imgInfo.indexOf('%perc') > 0) {
						info = info.replace('%perc', (~~(0.5 + 1E4 * (img.width / img.naturalWidth)) / 100));
					}

					if (prefs.imgInfo.indexOf('t:') === 0) {
						doc.title = info.substr(2);
					}
					else {
						win.status = info.substr(2);
					}
				}

				var hLayer, createHelper = function () {
					if (hLayer) { return; }

					hLayer = doc.createElement('DIV');
					hLayer.style.cssText = 'position:fixed;display:none;z-index:665;left:0px;top:0px;width:100%;height:100%;box-sizing:border-box;background-clip:padding-box;white-space:nowrap;color:#fff;text-shadow:1px 1px 1px #000;overflow:hidden';
					doc.body.appendChild(hLayer);
				};

				img.setPos = function() {
					if (prefs.pos.length === 2) {
						var bgM = (prefs.dam === 4), bgPos = '';

						var r = this.currentdeg && Math.sin(this.currentdeg) ? true : false;

						switch (prefs.pos.charAt(1)) {
							case '0' : if (bgM) { bgPos = 'top '; } else { this.style.top = '0px'; } break;
							case '2' : if (bgM) { bgPos = 'bottom '; } else { this.style.top = Math.max(0, doc.body.clientHeight - (r ? this.width : this.height) - borderSize * 2) + 'px'; } break;
							default: if (bgM) { bgPos = 'center '; } else { this.style.top = Math.max(0, (doc.body.clientHeight - (r ? this.width : this.height)) / 2 - borderSize) + 'px'; }
						}

						switch (prefs.pos.charAt(0)) {
							case '0' : if (bgM) { bgPos += 'left'; } else { this.style.left = '0px'; } break;
							case '2' : if (bgM) { bgPos += 'right'; } else { this.style.left = Math.max(0, doc.body.clientWidth - (r ? this.height : this.width) - borderSize * 2) + 'px'; } break;
							default : if (bgM) { bgPos += 'center'; } else { this.style.left = Math.max(0, (doc.body.clientWidth - (r ? this.height : this.width)) / 2 - borderSize) + 'px'; }
						}

						if (bgM) { this.parentNode.style.backgroundPosition = bgPos; }
					}
				};

				img.calcFit = function () {
					noFit = {
						cur: (this.width <= win.innerWidth && this.height <= win.innerHeight),
						real: (this.naturalWidth <= win.innerWidth && this.naturalHeight <= win.innerHeight)
					};
				};

				img.wheelZoom = function (e) {
					e.preventDefault();

					var w = img.width + 2 * borderSize, h = img.height + 2 * borderSize;

					if (e.wheelDelta > 0) {
						var width = w * (e.altKey || e.accelerate ? 1.4 : 1.2);

						img.resize(-1, (width > 10 ? width : width + 3) + 'px', 'auto');
					}
					else {
						img.resize(-1, Math.max(1, w * (e.altKey || e.accelerate ? 0.6 : 0.8)) + 'px', 'auto');
					}

					if ((e.target.nodeName == 'IMG' || e.keypress)) {
						win.scrollTo(e.offsetX * (img.width + 2 * borderSize) / w - e.clientX + borderSize, e.offsetY * (img.height + 2 * borderSize) / h - e.clientY + borderSize);
					}
				};

				if (prefs.scrollZoom) {
					img.hScroll = function () {};

					doc.addEventListener('mousewheel', img.wheelZoom, false);
				}
				else {
					if (prefs.hideSB) {
						var onWheelVertical = function (e) {
							win.scrollBy(0, -e.wheelDelta);
							e.preventDefault();
						};

						doc.addEventListener('mousewheel', onWheelVertical, false);
					}

					var onWheelHorizontal = function (e) {
						win.scrollBy(-e.wheelDelta, 0);
						e.preventDefault();
					};

					img.hScroll = function (force) {
						var hS;

						switch (prefs.dam) {
							case -1:
							case 0: hS = (win.innerWidth < this.width && prefs.hlonger && this.height <= (this.width / prefs.hlonger) ? true : false); break;
							case 3: hS = (win.innerWidth < this.width ? true : false); break;
							default: hS = false;
						}

						if (force) {
							hS = !hS;

							win.onkeyup = function(e) {
								if (e.keyCode === 88) {
									img.hScroll();
									win.onkeyup = null;
								}
							};
						}
						if (hS) { doc.addEventListener('mousewheel', onWheelHorizontal, false); if (prefs.hideSB) { doc.removeEventListener('mousewheel', onWheelVertical, false); }}
						else { doc.removeEventListener('mousewheel', onWheelHorizontal, false); if (prefs.hideSB) { doc.addEventListener('mousewheel', onWheelVertical, false); }}
					};
				}

				if (prefs.cursor) {
					img.setCur = function () {
						if (this.width > win.innerWidth || this.height > win.innerHeight) {
							this.style.cursor = 'move';
						}
						else if (((win.innerHeight >= this.height && win.innerWidth >= this.width) && (win.innerHeight < this.naturalHeight || win.innerWidth < this.naturalWidth)) ||
						(noFit.cur && noFit.real && (this.height < this.naturalHeight || this.width < this.naturalWidth))) {
							this.style.cursor = 'zoom-in';
						}
						else { this.style.cursor = 'default'; }
					};
				}
				else {
					img.setCur = function () {};
				}

				win.addEventListener('resize', function () {
					img.setPos();
					img.calcFit();
					img.hScroll();
					img.setCur();
					img.setInfo();
				}, false);

				var cxmenu, contextmenu = function (mx, my) {
					createHelper();

					if (cxmenu) {
						cxmenu.style.left = mx + 'px';
						cxmenu.style.top = my + 'px';
						hLayer.style.border = 0;
						hLayer.style.left = 0;
						hLayer.style.top = 0;
						hLayer.style.width = '100%';
						hLayer.style.height = '100%';
						hLayer.appendChild(cxmenu);
						hLayer.style.display = 'block';
						return;
					}

					/*-o-transition:opacity 300ms;opacity:0;*/
					document['head'].firstChild.innerText += '#O_EX_CM{display:none;position:fixed;text-shadow:none;z-index:666}#O_EX_CM,#O_EX_CM ul{background-color:#f0f0f0;border:1px solid #a0a0a0;box-shadow:2px 2px 2px #8e8e8e;display:inline-block;list-style:none;margin:0;padding:2px}#O_EX_CM li{position:relative}#O_EX_CM li ul{display:none;left:100%;position:absolute;top:-5px}#O_EX_CM li:hover ul{display:block}#O_EX_CM li a+i{color:grey;font-style:normal;position:absolute;right:5px;text-shadow:0 0 1px #fff;top:2px}#O_EX_CM .title{color:silver;letter-spacing:1px;padding:10px 5px 6px;text-shadow:0 0 0 #000}#O_EX_CM li:empty{border-bottom:1px solid #fff;border-top:1px solid #a0a0a0;margin:5px 7px 4px}#O_EX_CM .title:first-child{padding-top:0}#O_EX_CM a{border:1px solid transparent;color:#000;cursor:default;display:block;padding:2px 45px 2px 10px;text-decoration:none;white-space:nowrap}#O_EX_CM a:hover{background-color:#46a9ff;border:1px solid #1676ff;color:#fff}#O_EX_CM a:hover+i{color:#fff}';
					cxmenu = doc.createElement('UL');
					cxmenu.id = 'O_EX_CM';

					hLayer.appendChild(cxmenu);

					var generateMenu = function (ext_menu_data) {
						var tmpel, mfragment = doc.createDocumentFragment(), a, key, i, l;

						for (i = 0, l = ext_menu_data.length; i < l; ++i) {
							if (!ext_menu_data[i].length) {
								mfragment.appendChild(doc.createElement('LI'));
							}
							else if (ext_menu_data[i][1] instanceof Array) {
								tmpel = doc.createElement('LI');
								a = doc.createElement('A'); ul = doc.createElement('UL');
								a.innerText = ext_menu_data[i][0];
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('I');
									key.innerHTML = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								ul.appendChild(generateMenu(ext_menu_data[i][1]));
								tmpel.appendChild(ul);
								mfragment.appendChild(tmpel);
							}
							else {
								tmpel = doc.createElement('LI');
								a = doc.createElement('A');
								a.innerText = ext_menu_data[i][0];

								if (ext_menu_data[i][1]) { a.onclick = ext_menu_data[i][1]; }
								tmpel.appendChild(a);

								if (ext_menu_data[i][2]) {
									key = doc.createElement('I');
									key.innerText = ext_menu_data[i][2];
									tmpel.appendChild(key);
								}

								mfragment.appendChild(tmpel);
							}
						}

						return mfragment;
					};

					var tmpel, mfragment = doc.createDocumentFragment();

					tmpel = doc.createElement('LI');
					tmpel.className = 'title';
					tmpel.innerText = 'Imagus';
					mfragment.appendChild(tmpel);
					mfragment.appendChild(generateMenu([
						[LN('ORIGINAL_SIZE'), function() { img.resize(0); }, String.fromCharCode(prefs.keys['modeAuto'])],
						[LN('BEST_FIT'), function() { img.resize(1); }, String.fromCharCode(prefs.keys['modeFit'])],
						[LN('FIT_TO_WIDTH'), function() { img.resize(2); }, String.fromCharCode(prefs.keys['modeFitW'])],
						[LN('FIT_TO_HEIGHT'), function() { img.resize(3); }, String.fromCharCode(prefs.keys['modeFitH'])],
						[LN('MORE'), [
							[LN('TO_BACKGROUND'), function() { img.resize(4); }, String.fromCharCode(prefs.keys['modeBg'])],
							[LN('CUSTOM_SIZE'), function() { img.setSize(); }, String.fromCharCode(prefs.keys['customSize'])],
							[LN('RESET_IMAGE'), function() { img.reset(true); }, 'Esc']
						], '&#187;'],
						[],
						[LN('TRANSFORM'), [
							[LN('FLIP_H'), function() { img.flip(1); }, String.fromCharCode(prefs.keys['flipH'])],
							[LN('FLIP_V'), function() { img.flip(0); }, String.fromCharCode(prefs.keys['flipV'])],
							[],
							[LN('ROT_LEFT'), function() { img.rotate(false); }, String.fromCharCode(prefs.keys['rotateLeft'])],
							[LN('ROT_RIGHT'), function() { img.rotate(true); }, String.fromCharCode(prefs.keys['rotateRight'])],
							[LN('ROT_CUSTOM'), function() { img.rotate(); }, String.fromCharCode(prefs.keys['rotateCustom'])]
						], '&#187;'],
						[LN('IMG_SEARCH'), [
							['Google', function() { reverseImgSearch(img.src, 0); }],
							['TinEye', function() { reverseImgSearch(img.src, 1); }],
							[LN('BOTH'), function() { reverseImgSearch(img.src); }, String.fromCharCode(prefs.keys['imgSearch'])]
						], '&#187;'],
						[LN('PREFERENCES'), function() { oex.postMessage({'cmd': 'open', 'url': 'options.html'}); }, String.fromCharCode(prefs.keys['prefs'])]
					]));

					cxmenu.style.cssText = 'left:' + mx + 'px;top:' + my + 'px;display:block';
					cxmenu.appendChild(mfragment);

					hLayer.style.border = 0;
					hLayer.style.left = 0;
					hLayer.style.top = 0;
					hLayer.style.width = '100%';
					hLayer.style.height = '100%';
					hLayer.style.display = 'block';
				};

				doc.addEventListener('contextmenu', function(e) {
					win.onmousemove = null;
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction === 2) { cancelAction = false; e.preventDefault(); }
				}, false);

				var onmove = function (e) {
					if (fZoom) {
						if (fZoom.stage === 0) {
							if (!e.shiftKey) {
								fZoom = null;
								return;
							}

							createHelper();
							hLayer.innerHTML = '';
							cxmenu = null;

							var rot = img.currentdeg && Math.sin(img.currentdeg) ? true : false,
								w = rot ? img.height : img.width,
								h = rot ? img.width : img.height;
							if (w > win.innerWidth) {
								hLayer.style.left = parseInt(borderSize, 10);
								hLayer.style.width = win.innerWidth + 'px';
							}
							else {
								hLayer.style.left = (img.offsetLeft + borderSize) + 'px';
								hLayer.style.width = w + 'px';
							}

							if (h > win.innerHeight) {
								hLayer.style.top = parseInt(borderSize, 10);
								hLayer.style.height = win.innerHeight + 'px';
							}
							else {
								hLayer.style.top = (img.offsetTop + borderSize) + 'px';
								hLayer.style.height = h + 'px';
							}

							// helper width, height
							fZoom.hW = parseInt(hLayer.style.width, 10);
							fZoom.hH = parseInt(hLayer.style.height, 10);

							// helper top, left
							fZoom.hT = parseInt(hLayer.style.top, 10);
							fZoom.hL = parseInt(hLayer.style.left, 10);

							// helper right, bottom
							fZoom.hR = fZoom.hL + fZoom.hW;
							fZoom.hB = fZoom.hT + fZoom.hH;

							fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
							fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
							fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
							fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);

							// area width, height
							//fZoom.sW = Math.max(0, fZoom.hW - fZoom.hL - fZoom.hR);
							//fZoom.sH = Math.max(0, fZoom.hH - fZoom.hT - fZoom.hB);

							hLayer.style.borderStyle = 'solid';
							hLayer.style.borderColor = 'rgba(0,0,0,.5)';
							//hLayer.style.backgroundColor = 'rgba(0,255,255,.5)';
							hLayer.style.borderWidth = fZoom.t + 'px ' + fZoom.r + 'px ' + fZoom.b + 'px ' + fZoom.l + 'px';
							hLayer.style.display = 'block';

							++fZoom.stage;
						}
						else {
							if (e.ctrlKey) {
								if (fZoom.sX) {
									var x = fZoom.sX - e.screenX, y = fZoom.sY - e.screenY;

									if (y !== 0) {
										hLayer.style.borderBottomWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderBottomWidth, 10) + y), fZoom.hH) + 'px';
										hLayer.style.borderTopWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderTopWidth, 10) - y), fZoom.hH) + 'px';
									}

									if (x !== 0) {
										hLayer.style.borderRightWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderRightWidth, 10) + x), fZoom.hW) + 'px';
										hLayer.style.borderLeftWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderLeftWidth, 10) - x), fZoom.hW) + 'px';
									}
								}

								fZoom.sX = e.screenX;
								fZoom.sY = e.screenY;

								return;
							}

							if (fZoom.sX) {
								fZoom.sX = null;
								fZoom.sY = null;
								/*fZoom.cX = fZoom.hL + (fZoom.cX < e.clientX ? parseInt(hLayer.style.borderLeftWidth, 10) : fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10));
								fZoom.cY = fZoom.hT + (fZoom.cY < e.clientY ? parseInt(hLayer.style.borderTopWidth, 10) : fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10));*/
								if (fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10) < e.clientX) { fZoom.cX = fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10); }
								else { fZoom.cX = fZoom.hL + fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10); }

								if (fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10) < e.clientY) { fZoom.cY = fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10); }
								else { fZoom.cY = fZoom.hT + fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10); }

								//borders
								fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
								fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
								fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
								fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);
							}

							var t, r, b, l;

							if (fZoom.cY < e.clientY) {
								b = Math.max(0, fZoom.hB - e.clientY);
								t = fZoom.t;
							}
							else {
								b = fZoom.b;
								t = Math.max(0, e.clientY - fZoom.hT);
							}

							if (fZoom.cX < e.clientX) {
								r = Math.max(0, fZoom.hR - e.clientX);
								l = fZoom.l;
							}
							else {
								r = fZoom.r;
								l = Math.max(0, e.clientX - fZoom.hL);
							}

							hLayer.style.borderWidth = t + 'px ' + r + 'px ' + b + 'px ' + l + 'px';
						}

						return;
					}

					if (progress) { clearTimeout(progress); progress = null;}

					if (sX === true || prefs.pixelmove < 1 || noFit.cur || !parseInt(prefs.pixelmove, 10)) { win.onmousemove = null; return;}

					if (!--pixelThresHold) {
						win.scrollBy(sX - e.screenX, sY - e.screenY);

						sX = e.screenX;
						sY = e.screenY;
						pixelThresHold = prefs.pixelmove;
					}

					if (dragScroll.length !== 3) {
						dragScroll = [ [e.screenX, e.screenY], [e.screenX, e.screenY], [e.screenX, e.screenY] ];
						return;
					}

					//dragScroll = [[dragScroll[1][0], dragScroll[1][1]], [dragScroll[2][0], dragScroll[2][1]], [e.screenX, e.screenY]];

					dragScroll[0] = [dragScroll[1][0], dragScroll[1][1]];
					dragScroll[1] = [dragScroll[2][0], dragScroll[2][1]];
					dragScroll[2] = [e.screenX, e.screenY];

					img.dragScrollTime = Date.now();
				};

				if (prefs.dragScroll) {
					var stopScroll = function (e, c_action) {
						if (dragScroll.length) {
							clearInterval(progress);
							progress = null;
							cancelAction = c_action ? true : false;
							dragScroll = [];
							img.dragScrollTime = false;
						}

						if (e) {
							doc.removeEventListener('mousewheel', stopScroll, false);
						}
					};

					var scroll = function () {
						win.scrollBy(dragScroll[0], dragScroll[1]);

						if (dragScroll[0]) {
							if (Math.abs(dragScroll[0]) < 1) {
								dragScroll[0] = 0;
							}

							dragScroll[0] /= prefs.dragScroll;
						}

						if (dragScroll[1]) {
							if (Math.abs(dragScroll[1]) < 1) {
								dragScroll[1] = 0;
							}

							dragScroll[1] /= prefs.dragScroll;
						}

						var atRight = root.scrollWidth - win.scrollX === root.clientWidth,
							atBottom = root.scrollHeight - win.scrollY === root.clientHeight;

						if (!(dragScroll[0] && dragScroll[1]) || (!win.scrollY && !win.scrollX) || (!win.scrollY && atRight) || (atBottom && !win.scrollX) || (atBottom && atRight)) {
							stopScroll();
						}
					};
				}

				var handle_mDown = function(e) {
					if (e.button === 1 || e.ctrlKey || e.altKey) { return; }

					if ((e.button === 0 && prefs.dam < 4) || e.button === 2) {
						if (prefs.pixelmove) {
							win.onmousemove = onmove;
						}
						else {
							win.onmousemove = function () {if (progress) { clearTimeout(progress); progress = null; } win.onmousemove = null; };
						}

						if (e.button === 2) {
							sX = true;
						}
						else {
							e.preventDefault();
							sX = e.screenX;
							sY = e.screenY;
						}
					}

					if (!prefs.mDownDelay) {
						return;
					}

					// for fine move and free zoom
					if (e.shiftKey || fZoom === 0) {
						cancelAction = true;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;
							contextmenu(e.clientX, e.clientY);
						}
						else {
							fZoom = {stage: 0, cX: e.clientX, cY: e.clientY};

							if (win.onmousemove === null) {
								win.onmousemove = onmove;
							}
						}
					}

					// is dragScrolling
					if (progress) {
						stopScroll && stopScroll(false, true);

						if (e.button === 0) {
							return;
						}
					}

					if (e.shiftKey) { return; }

					progress = setTimeout(function () {
						cancelAction = true;
						progress = null;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;

							try { if (img.src !== win.top.location.href) { oex.postMessage({'cmd': 'open', 'url': img.src, nf: false}); return; } } catch (ex) {}

							contextmenu(e.clientX, e.clientY);
							return;
						}

						var x, y, tmpsize;

						if (prefs.dam === 2 || img.width === win.innerWidth) {
							tmpsize = img.width;

							img.resize(3);

							x = e.offsetX * img.width / tmpsize - win.innerWidth / 2;
							y = 0;
						}
						else {
							tmpsize = img.height;

							img.resize(2);

							x = 0;
							y = e.offsetY * img.height / tmpsize - win.innerHeight / 2;
						}

						win.scrollTo(x, y);
					}, prefs.mDownDelay);
				};

				img.addEventListener('mousedown', handle_mDown, false);

				doc.addEventListener('mouseup', function(e) {
					if (hLayer && hLayer.style.display == 'block' && !fZoom) {
						if (e.target == hLayer || (e.target.nodeName == 'A' && !e.shiftKey)) { hLayer.style.display = 'none'; }
						return;
					}

					if (e.button !== 0) { return; }

					if (prefs.dam < 4) {
						win.onmousemove = null;

						if (fZoom) {
							hLayer.style.display = 'none';
							var nimgw, nimgh,
							w = fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10),
							h = fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10),
							scrollbars = prefs.hideSB ? 0 : 17, // not always 17
							winW = win.innerWidth - scrollbars,
							winH = win.innerHeight - scrollbars;

							var fitW = winW < w * winH / h;

							fitW = e.ctrlKey ? !fitW : fitW;

							if (fitW) {
								nimgw = img.width * winW / w;
								nimgh = nimgw * img.height / img.width;
							}
							else {
								nimgh = img.height * winH / h;
								nimgw = nimgh * img.width / img.height;
							}

							// not needed in Opera 12
							if (nimgw > MAXSIZE) {
								nimgw = MAXSIZE;
								nimgh = img.height * MAXSIZE / img.width;
							}

							if (nimgh > MAXSIZE) {
								nimgw = img.width * MAXSIZE / img.height;
								nimgh = MAXSIZE;
							}

							var cx = (win.scrollX + parseInt(hLayer.style.borderLeftWidth, 10) + w / 2) * nimgw / img.width - win.innerWidth / 2 - scrollbars;
							var cy = (win.scrollY + parseInt(hLayer.style.borderTopWidth, 10) + h / 2) * nimgh / img.height - win.innerHeight / 2 - scrollbars;

							img.resize(-1, nimgw + 'px', nimgh + 'px');

							win.scrollTo(cx, cy);

							fZoom = null;
							cancelAction = false;
							hLayer.innerText = '';
						}
						else if (dragScroll.length === 3) {
							var x = dragScroll[0][0] - dragScroll[2][0], y = dragScroll[0][1] - dragScroll[2][1];

							if ((Date.now() - img.dragScrollTime) > 100) { return; }

							//x = x < 0 ? Math.max(-1e3, x) : Math.min(1e3, x);
							//y = y < 0 ? Math.max(-1e3, y) : Math.min(1e3, y);

							if (x || y) {
								dragScroll = [x, y];
								progress = setInterval(scroll, 0xF);
								doc.addEventListener('mousewheel', stopScroll, false);
							}
						}
					}
				}, false);

				img.addEventListener('click', function(e) {
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction) { cancelAction = false; return; }

					if (e.button !== 0) { return; }

					if (prefs.dam < 2 && noFit.real) {
						if (prefs.dam === -1) { this.resize(0); }
						else if (win.innerWidth < this.naturalWidth * win.innerHeight / this.naturalHeight) { this.resize(2); }
						else { this.resize(3); }
					}
					else if (prefs.dam === 1 || noFit.cur) {
						if (this.naturalWidth === this.width && this.naturalHeight === this.height) { return; }

						var x, y;

						x = e.offsetX;
						y = e.offsetY;

						if (this.scale) {
							if (this.scale.h === -1) {
								x = this.width - e.offsetX;
							}

							if (this.scale.v === -1) {
								y = this.height - e.offsetY;
							}
						}

						x = x * this.naturalWidth / this.width - win.innerWidth / 2;
						y = y * this.naturalHeight / this.height - win.innerHeight / 2;

						this.resize(0);

						win.scrollTo(x, y);
					}
					else { this.resize(1); }
				}, false);

				doc.addEventListener('keypress', function(e) {
					if (e.keyCode === 43 || e.keyCode === 45) {
						e.accelerate = e.ctrlKey;
						e.keypress = true;

						if (e.keyCode === 43) {
							e.wheelDelta = 1;
						}
						else {
							e.wheelDelta = -1;
						}

						e.offsetX = root.scrollLeft + img.offsetLeft + doc.body.clientWidth / 2;
						e.offsetY = root.scrollTop + img.offsetTop + doc.body.clientHeight / 2;
						e.clientX = doc.body.clientWidth / 2;
						e.clientY = doc.body.clientHeight / 2;

						img.wheelZoom(e);
					}
				}, false);

				doc.addEventListener('keydown', function(e) {
					stopScroll();

					if ((fZoom && e.keyCode !== 27) || /(?:TEXTAREA|INPUT|SELECT)/.test(e.target.nodeName)) { return; }

					if (e.ctrlKey) {
						if (e.shiftKey && ' 37 38 39 40 '.indexOf(' ' + e.keyCode + ' ') != -1) {
							var newpos,
							x = prefs.pos.charAt(0),
							y = prefs.pos.charAt(1);

							switch (e.keyCode) {
								case 37: --x; break;
								case 39: ++x; break;
								case 38: --y; break;
								case 40: ++y;
							}

							x < 0 ? x = '0' : x > 2 && (x = '2');
							y < 0 ? y = '0' : y > 2 && (y = '2');

							newpos = x + y;

							if (newpos !== prefs.pos) {
								prefs.pos = newpos;
								img.setPos();
							}
						}

						return;
					}

					switch (e.keyCode) {
						case prefs.keys['modeAuto'] : case prefs.keys['modeFit']: case prefs.keys['modeFitW']: case prefs.keys['modeFitH']: case prefs.keys['modeBg']: img.resize(e.keyCode - 49); break;

						case prefs.keys['customSize'] : img.setSize(); break;

						case 27 : img.reset(); break;

						case prefs.keys['prefs'] : oex.postMessage({'cmd': 'open', 'url': 'options.html'}); break;

						case prefs.keys['rotateLeft'] : img.rotate(false, e.shiftKey); break;
						case prefs.keys['rotateRight'] : img.rotate(true, e.shiftKey); break;
						case prefs.keys['rotateCustom'] : img.rotate(); break;

						case prefs.keys['flipH'] : img.flip(0); break;
						case prefs.keys['flipV'] : img.flip(1); break;

						case prefs.keys['imgSearch'] : reverseImgSearch(img.src, e.shiftKey); break;

						case prefs.keys['cycle'] : img.cycle(); break;

						case prefs.keys['contextMenu'] : hLayer && hLayer.style.display == 'block' ? (hLayer.style.display = 'none') : contextmenu(win.innerWidth / 2 - 100, win.innerHeight / 2 - 100); break;

						case 88 : img.hScroll(true); break;

						case 68 :
							if (!win.onkeyup) {
								img.removeEventListener('mousedown', handle_mDown, false);

								win.onkeyup = function(e) {
									if (e.keyCode === 68) {
										img.addEventListener('mousedown', handle_mDown, false);
										win.onkeyup = null;
									}
								};
							}
						break;
					}
				}, false);

				img.cycle = function () {
					var n_s = prefs.dam + 1;

					if (n_s === 1) { ++n_s; }
					else if (n_s > 3) { n_s = 0; }

					this.resize(n_s);
				};

				img.reset = function (keep_hLayer) {
					if (doc.readyState !== 'complete') { return; }

					if (!keep_hLayer && hLayer) {
						fZoom = null;
						cancelAction = false;

						if (hLayer.style.display == 'block') {
							hLayer.innerHTML = '';
							hLayer.style.display = 'none';
							return;
						}

						doc.body.removeChild(hLayer);
						hLayer = null;
					}

					delete this.currentdeg;
					delete this.scale;
					this.style['OTransform'] = this.parentNode.style['backgroundSize'] = this.style.width = this.style.height = '';
					this.resize(0);
				};

				img.setSize = function () {
					setTimeout(function() {
						var size = prompt('(0 < x,y <= ' + MAXSIZE + ')\n' + LN('ORIG_DIMENS') + ': ' + img.naturalWidth + ' x ' + img.naturalHeight, '0');

						if (!size) { return; }

						size = size.replace(/(^\s*|\s*$)/g, '');

						if (/^(\d{1,5}%?)(\s+\d{1,5}%?)?$/i.test(size)) {
							size = size.split(/\s+/);

							if (prefs.dam === 4) {
								if (size[0] == 0) { size[0] = 'auto'; }
								if (size[1] && size[1] == 0) { size[1] = 'auto'; }
								doc.body.style.backgroundSize = size.join(' ');
							}
							else {
								var w = '', h = '';

								if (parseInt(size[0], 10) > 0) {
									w = size[0].indexOf('%') > 0 ? size[0] : Math.min(Math.max(0, size[0]), MAXSIZE) + 'px';
								}

								if (size[1] && parseInt(size[1], 10) > 0) {
									h = size[1].indexOf('%') > 0 ? size[1] : Math.min(Math.max(0, size[1]), MAXSIZE) + 'px';
								}

								img.resize(-1, w, h);
							}
						}
						else { alert(LN('INCORRECT_VALUE')); }
					}, 1);
				};

				img.rotate = function (deg, fine) {
					setTimeout(function() {
						var rot = img.style['OTransform'].match(/rotate\((\-?\d+(?:\.\d+)?)deg\)/i);

						if (rot) { rot = rot[1]; }
						else { img.currentdeg = rot = 0; }

						if (deg === undefined && !/^\s*-?\d+(?:\.\d+)?\s*$/.test(deg = prompt('°:', rot))) {
							if (deg) { alert(LN('INCORRECT_VALUE')); }
							return;
						}

						if (deg === true) { img.currentdeg += (fine ? 10 : 90); }
						else if (deg === false) { img.currentdeg -= (fine ? 10 : 90); }
						else { img.currentdeg = deg; }

						//if (img.currentdeg !== 0 && Math.cos(img.currentdeg * 0.017453292519943295) === 1) { img.currentdeg = 0; }

						win.status = img.currentdeg + '°';

						if (typeof img.currentdeg !== 'undefined') { rot = 'rotate(' + img.currentdeg + 'deg)'; }
						if (img.scale) { rot += ' scale(' + img.scale.h + ',' + img.scale.v + ')'; }
						img.style['OTransform'] = rot;
					}, 1);
				};

				img.flip = function (ori) {
					if (!this.scale) { this.scale= {h: 1, v: 1 }; }

					if (ori) { this.scale.h = -this.scale.h; }
					else { this.scale.v = -this.scale.v; }

					var flip = (!this.scale.h && !this.scale.v) ? '' : 'scale('+this.scale.h+','+this.scale.v+')';
					if (this.currentdeg) { flip='rotate('+this.currentdeg+'deg) ' + flip; }
					this.style['OTransform'] = flip;
				};

				// don't upscale large images
				if ((prefs.dam === 2 && img.naturalWidth < win.innerWidth) || (prefs.dam === 3 && img.naturalHeight < win.innerHeight)) {
					prefs.dam = 0;
				}

				img.resize(prefs.dam); //setTimeout(function () { img.resize(prefs.dam); }, 0);
				setTimeout(img.setInfo, 1500);
			}
			else if (++init.loop >= init.maxloop) {
				clearInterval(progress);
			}
		};

		if (img.naturalWidth && img.naturalHeight) { load(true); }
		else { progress = setInterval(load, init.wait); }

		oex.removeEventListener('message', arguments.callee, false);
	}, false);

	win.onkeypress = win.onmousedown = win.onmouseup = null;
}
else {
	var isHTML = document instanceof win['HTMLDocument'] || (doc.documentElement && root.nodeName == 'HTML');

	if (isHTML) {
		var mdownstart,
				rgxBgURL = /"[^"]+"/g, //g for mutlitple backgrounds
				rgxProtCheck = /^\w+:/i,
				rgxQueryHash = /[\?#].*/,
				rgxHash = /#.*/,
				rgxDomain = /^(\w+:\/\/[^\/]+)\/.*/,
				rgxPath = /(\/)[^\/]*$/,
				// http://www.opera.com/docs/specs/presto211/#graphics
				rgxObjImg = /\.(?:jp(?:e|e?g)|a?png|gif|svgz?|webp|w?bmp|cur|ico|xbm|pict|j(?:if|fif?))$/i,

		checkBG = function (match/*, p*/) {
			if (match) {
				var el_images = [], imaddr, i;

				for (i in match) {
					imaddr = match[i].slice(1, -1);

					// need this check, because Opera won't prepend the baseURI to background attribute
					if (!rgxProtCheck.test(imaddr)) {
						imaddr = doc.baseURI.replace(rgxQueryHash, '').replace((imaddr.charAt(0) == '/' ? rgxDomain : rgxPath), '$1') + imaddr;
					}

					el_images.push(imaddr);
				}

				//return p && el_images.length > 0 ? {path: p, imgs: el_images} : el_images;
				return el_images.length > 0 ? el_images : null;
			}

			return null;
		},

		checkIMG = function (node) {
			if (node.nodeName == 'IMG' || (node.type == 'image' && /^(?:BUTTON|INPUT)/.test(node.nodeName))) {
				return node.src;
			}
			else if (node.nodeName == 'EMBED') {
				return node.baseURI.replace(rgxQueryHash, '').replace((node.src.charAt(0) == '/' ? rgxDomain : rgxPath), '$1') + node.src;
			}
			else if (node.nodeName == 'OBJECT' && node.data !== ''/* && (/^image/i.test(node.type) || rgxObjImg.test(node.data))*/) {
				return node.data;
			}
			else if (node.nodeName == 'AREA') {
				var img = doc.querySelector('img[usemap="#' + node.parentNode.name + '"]');
				return img.src;
			}
			else if (node.nodeName == 'VIDEO' && node.poster !== '') {
				return node.poster;
			}

			return false;
		};
	}

	win.opera.addEventListener('BeforeEvent.mousedown', function (e) {
		if (e.event.button === 2) { mdownstart = Date.now(); }
	}, false);

	win.opera.addEventListener('BeforeEvent.contextmenu', function (ev) {
		var e = ev.event;

		if (e.button !== 2) { return; }

		var img, el, i, bgImages = [], elapsed = (Date.now() - mdownstart) >= 300;
		mdownstart = 0;

		if (e.ctrlKey && e.altKey) {
			if (elapsed) {
				ev.preventDefault();
				e.preventDefault();
				oex.postMessage({'cmd': 'favi', nf: e.shiftKey});
			}
			else {
				// reverse search
			}

			return;
		}

		if (e.ctrlKey && elapsed) {
			el = e.target;
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (i === 9) {
					el = el.previousElementSibling || el.parentNode;
				}
				else {
					if (el.childElementCount) {
						el = el.lastElementChild;
					}
					else if (el.previousElementSibling) {
						el = el.previousElementSibling;
					}
					else if (el.parentNode) {
						el = el.parentNode.previousElementSibling;
					}
					else {
						el = false;
					}
				}
			}

			// need check
			el = e.target.childElementCount ? e.target.firstElementChild : (e.target.nextElementSibling || e.target.parentNode.nextElementSibling);
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (el.childElementCount) {
					el = el.firstElementChild;
				}
				else if (el.nextElementSibling) {
					el = el.nextElementSibling;
				}
				// while el.parentNode.nextElementSibling or not
				else if (el.parentNode && el.parentNode.nextElementSibling) {
					el = el.parentNode.nextElementSibling;
				}
				else {
					el = false;
				}
			}
		}

		if ((e.altKey || elapsed) && !(e.altKey && elapsed)) {
			if (e.target.document instanceof win['SVGDocument']) {
				if (e.target.document.URL !== win.top.location.href) {
					bgImages.push(e.target.document.URL);
				}
			}
			else {
				img = checkIMG(e.target);
				img && bgImages.push(img);
			}
		}

		if ((e.ctrlKey || elapsed) && !(e.ctrlKey && elapsed) && !(e.target.document instanceof win['SVGDocument'])) {
			el = e.target;

			if (el.nodeName == 'HTML') {
				img = checkBG(el.currentStyle.backgroundImage.match(rgxBgURL) || doc.body.currentStyle.backgroundImage.match(rgxBgURL)/*, 'html>body'*/);
				img && (bgImages = bgImages.concat(img));
			}
			else {
				var imgList;//, path = '';

				while(el && el.nodeName !== '#document') {
					//path = path ? el.nodeName + '>' + path : el.nodeName;
					match = el.currentStyle.backgroundImage.match(rgxBgURL);

					if (el.nodeName == 'UL') {
						var f = el.currentStyle.listStyleImage.match(rgxBgURL);
						if (f) {
							if (match) { match.push(f); }
							else { match = f; }
						}
					}

					imgList = checkBG(match/*, path*/);
					imgList && (bgImages = bgImages.concat(imgList));

					el = el.parentNode;
				}
			}
		}

		if (bgImages && bgImages.length > 0) {
			ev.preventDefault();
			e.preventDefault();

			if (!(e.ctrlKey && e.altKey) && !(e.ctrlKey && elapsed)) {
				oex.postMessage({'cmd': 'open', 'url': bgImages[0], nf: e.shiftKey});
			}
			else {
				if (bgImages.length > 1) {
					var a = [], l = bgImages.length, j;

					for (i = 0; i < l; ++i) {
						for (j = i + 1; j < l; ++j) {
							if (bgImages[i] == bgImages[j]) {
								j = ++i;
							}
						}

						a.push(bgImages[i]);
					}

					bgImages = a;
				}

				for (i = 0; i < bgImages.length; ++i) {
					oex.postMessage({'cmd': 'open', 'url': bgImages[i], nf: e.shiftKey});
				}
			}
		}
	}, false);

	if (!isHTML) { return; }
}

var reverseImgSearch = function (url, which) {
	var i = 0, hosts = ['google.com/searchbyimage?image_', 'tineye.com/search?'], go = [];

	if (which !== undefined && typeof which != 'boolean' && hosts[which]) {
		go = 'http://www.' + hosts[which] + 'url=' + encodeURIComponent(url);
	}
	else {
		for (; i < hosts.length; ++i) {
			if (cfg.tools['imgSearchHost'] == i || cfg.tools['imgSearchHost'] == hosts.length) {
				go.push('http://www.' + hosts[i] + 'url=' + encodeURIComponent(url));
			}
		}
	}

	oex.postMessage({'cmd': 'open', 'url': go, 'nf': typeof which == 'boolean' ? which : false});
};

var PVI = {
	sieve: {},
	PrevDIV: null,
	PrevOBJ: null,
	helper_div: null,
	target: null,
	img: null,
	imageStack: {},
	collectxy: false,
	xy: [],
	timers: {imload: null, preview: null},
	resolving: {counter: 0, nodes: {}},
	anim: {},
	create: function () {
		if (PVI.PrevDIV) { return; }

		root || (root = doc.documentElement);
		PVI.PrevDIV = doc.createElement('DIV');
		PVI.PrevOBJ = doc.createElement('OBJECT');

		var bg = '', div_caption;

		if (PVI.cfg['background']) {
			if (PVI.cfg['background'] == 'cb') {
				bg = ';background-color:rgba(0,0,0,0);background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)';
			}
			else if (/(?:http|-o-skin)/i.test(PVI.cfg['background'])) { bg = ';background-color:rgba(0,0,0,0);background-image:' + PVI.cfg['background']; }
			else { bg = ';background-color:' + PVI.cfg['background']; }

			bg += ';background-clip:content-box';
		}

		PVI.PrevDIV.style.cssText = 'position:fixed;z-index:2147483646;left:auto;top:auto;right:auto;bottom:auto;font-size:9pt;font-family:Verdana;color:#000' + bg + (PVI.cfg['shadow'] ? ';box-shadow:' + PVI.cfg['shadow'] : '') + (PVI.cfg['border'] ? ';border:' + PVI.cfg['border'] : '') + (PVI.cfg['fade'] ? ';opacity:0' : '');
		PVI.PrevOBJ.style.cssText = 'width:auto;height:auto;margin:0;-o-object-fit:contain' + (PVI.cfg['border'] ? ';border:1px solid #bbb' : '');
		PVI.PrevOBJ.type = 'image/jpeg';
		//PVI.PrevOBJ.data = 'data:image/gif;';
		PVI.PrevDIV.appendChild(PVI.PrevOBJ);
		//'<div style="position:absolute;top:0;right:0;background-color:rgba(0,0,0,0.2);color:#fff">' +
		//'<div>rotate left right</div><div>flipv flipH</div><div>upload</div><div>zoom-zoom</div></div>' +
		if (PVI.cfg['caption']) {
			div_caption = doc.createElement('DIV');
			div_caption.style.cssText = 'position:absolute;' + (PVI.cfg['caption'] === 1 ? 'top' : 'bottom') +':-1em;left:5px;margin-right:5px;white-space:nowrap;background-color:#fff;padding:0 5px;border-radius:4px;color:#000';
			PVI.PrevDIV.appendChild(div_caption);
		}

		PVI.PrevDIV.outsize = 2 * (PVI.cfg['margin'] + (PVI.cfg['border'] ? parseInt(PVI.PrevDIV.style.borderWidth, 10) + 1 : 0));
		PVI.anim.container = [];

		if (PVI.cfg['fade']) {
			PVI.anim.container.push('opacity ' + PVI.cfg['fade'] + 'ms');
			PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && this.style.opacity == '0') {
					PVI.reset();
				}
			}, false);
		}

		if (PVI.cfg['position']) {
			PVI.anim.container.push(['top', 'right', 'bottom', 'left'].join(' ' + PVI.cfg['position'] + 'ms, ') + ' ' + PVI.cfg['position'] + 'ms');

			!PVI.cfg['fade'] && PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && (parseInt(this.style.left, 10) < 0 || parseInt(this.style.right, 10) < 0)) {
					PVI.reset();
				}
			}, false);
		}

		if (PVI.cfg['sizing']) {
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj = 'max-width ' + PVI.cfg['sizing'] + 'ms, max-height ' + PVI.cfg['sizing'] + 'ms';
			PVI.PrevOBJ.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && PVI.PrevDIV.style.display == 'block' && this.style.maxWidth == '0px') {
					PVI.reset();
				}
			}, false);
		}

		if (PVI.anim.container.length) { PVI.PrevDIV.style['OTransition'] = PVI.anim.container = PVI.anim.container.join(', '); }

		root.appendChild(PVI.PrevDIV);

		PVI.helper_div = doc.createElement('DIV');
		PVI.helper_div.style.cssText = 'position:absolute;top:0;z-index:-666;height:100%;width:0;border:0;padding:0;margin:0;overflow:hidden';
		root.appendChild(PVI.helper_div);

		PVI.reset();
	},
	resolve: function (URL, res) {
		if (win.location.href.replace(rgxHash, '') == URL.replace(rgxHash, '')) { return false; } // maybe not the best idea

		clearTimeout(PVI.timers.imload);

		PVI.timers.imload = setTimeout(function () {
			PVI.resolving.nodes[++PVI.resolving.counter] = PVI.target;
			oex.postMessage({'cmd': 'resolve', 'url': URL, 'find': res, 'id': PVI.resolving.counter});
		}, PVI.cfg['hoverTime']);

		return true;
	},
	find: function (tt) {
		var i = 0, n = tt || PVI.target, ret = false, sieve, sn, imgSRC, imgBG, found;

		if (PVI.target.imagus_sieve_cache) {
			sieve = {};
			sieve[PVI.target.imagus_sieve_cache] = PVI.sieve[PVI.target.imagus_sieve_cache];
		}
		else {
			sieve = PVI.sieve;
		}

		do {
			if (n.href) {
				if (PVI.target.src && n.href == PVI.target.src || (!isRaster && win.location.href.replace(rgxHash, '') == n.href.replace(rgxHash, ''))) { break; }

				for (sn in sieve) {
					if (sieve[sn].link && sieve[sn].link.test(n[(sieve[sn].attr && n[sieve[sn].attr] ? sieve[sn].attr : 'href')])) {
						if (sieve[sn].useimg && sieve[sn].img) {
							if (!imgSRC && PVI.target.src) { imgSRC = PVI.target.src; } // PVI.target.nodeName == 'IMG'
							if (!imgBG && PVI.target.currentStyle.backgroundImage !== 'none') {
								imgBG = PVI.target.currentStyle.backgroundImage.match(rgxBgURL);
								if (imgBG) { imgBG = imgBG[0].slice(1, -1); }
							}

							if (imgSRC && sieve[sn].img.test(imgSRC) || imgBG && sieve[sn].img.test(imgBG)) {
								found = true;

								if (!PVI.target.imagus_sieve_cache) {
									sieve = {};
									sieve[sn] = PVI.sieve[sn];
								}

								break;
							}
						}

						if (sieve[sn].res && PVI.resolve((sieve[sn].url ? n.href.replace(sieve[sn].link, sieve[sn].url) : n.href), sieve[sn].res)) {
							ret = null;
							break;
						}

						ret = sieve[sn].to ? n.href.replace(sieve[sn].link, sieve[sn].to) : n.href;
						sieve[sn].decode && (ret = decodeURIComponent(decodeURIComponent(ret)));

						if (sieve[sn].loop) {
							ret = PVI.find({href: ret});
						}

						break;
					}
				}

				break;
			}
		} while (++i < 5 && (n = n.parentNode));

		if (!tt) {
			if (!ret && ret !== null) {
				if (!imgSRC && PVI.target.src) { imgSRC = PVI.target.src; } // PVI.target.nodeName == 'IMG'
				if (!imgBG && PVI.target.currentStyle.backgroundImage !== 'none') {
					imgBG = PVI.target.currentStyle.backgroundImage.match(rgxBgURL);
					if (imgBG) { imgBG = imgBG[0].slice(1, -1); }
				}

				if (imgSRC || imgBG) {
					var f_src = true;

					for (sn in sieve) {
						if (found === true || (sieve[sn].img && ((f_src = sieve[sn].img.test(imgSRC)) || sieve[sn].img.test(imgBG)))) {
							imgSRC = (f_src ? imgSRC : imgBG);

							if (!sieve[sn].to && sieve[sn].res && sieve[sn].url && PVI.resolve(imgSRC.replace(sieve[sn].img, sieve[sn].url), sieve[sn].res)) {
								ret = null;
							}
							else {
								ret = sieve[sn].to ? imgSRC.replace(sieve[sn].img, sieve[sn].to) : imgSRC;
								sieve[sn].decode && (ret = decodeURIComponent(ret));
							}

							found = 1;
							break;
						}
					}
				}
			}

			if (ret && ((imgSRC && imgSRC === ret) || (PVI.target.src && ret == PVI.target.src))) { ret = false; }

			if (PVI.cfg['zoomResized'] && PVI.target.src) {
				if (ret) {
					if (found === 1) {
						PVI.target.imagus_thumb = true;
					}
				}
				else if (ret !== null && (PVI.target.naturalWidth - PVI.cfg['zoomResized'] > PVI.target.clientWidth || PVI.target.naturalHeight - PVI.cfg['zoomResized'] > PVI.target.clientHeight) && PVI.target.clientWidth <= win.innerWidth && PVI.target.clientHeight <= win.innerHeight) {
					ret = PVI.target.src;
				}
			}

			ret && (ret = ret.replace(/#/g, '%23'));
		}

		if (ret || ret === null) {
			if (!tt) {
				n = PVI.target;

				do {
					if (n.title != '') {
						if (!PVI.target.imagus_title && PVI.cfg['caption']) {
							PVI.target.imagus_title = n.title;
						}

						n.title = '';
					}
				} while ((n = n.parentNode) && n.nodeName !== 'HTML');

				if (PVI.cfg['caption'] && !PVI.target.imagus_title && PVI.target.alt) {
					PVI.create();
					PVI.helper_div.innerHTML = PVI.target.alt.replace(/(?:\n|\r\n?)+/g, ' ').replace(/</g, '&lt;');
					PVI.target.imagus_title = PVI.helper_div.innerText;
					PVI.helper_div.innerText = '';
				}

				if (ret && rgxIsSVG.test(ret)) {
					PVI.target.imagus_SVG = true;
				}
			}

			(sieve[sn].cache === 1) && (PVI.target.imagus_sieve_cache || (PVI.target.imagus_sieve_cache = sn));
		}

		return ret;
	},
	show: function (pre) {
		!PVI.cfg['move'] && (PVI.collectxy = false);

		if (PVI.iFrame) {
			if (PVI.target.imagus_cache) { oex.postMessage({'cmd': 'from_frame', 'img': PVI.target.imagus_cache, 'svg': !!PVI.target.imagus_SVG}); }
			return;
		}

		if (PVI.hiding) {
			if (PVI.cfg['waitHide']) {
				return;
			}

			PVI.hiding = false;

			if (!PVI.target.imagus_cache) {
				delete PVI.PrevOBJ.data;
				PVI.PrevOBJ.innerText = 'Loddig...';
			}
		}
		else /*if (PVI.PrevDIV.style.display !== 'block') */{
			PVI.PrevDIV.style.display = 'block';
			PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '1');
			PVI.cfg['position'] && !pre && PVI.show(true);
		}

		var winW = Math.max(doc.body.clientWidth, root.clientWidth),
				winH,
				left, top, bottom, right;

		(winW > win.innerWidth) && (winW = win.innerWidth);
		//winH = win.innerHeight - ( winW < Math.max(doc.body.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);
		winH = PVI.helper_div.clientHeight;

		var rSide = winW - PVI.xy[0], bSide = winH - PVI.xy[1];

		if (PVI.xy[0] < rSide) {
			left = PVI.xy[0];
			PVI.PrevDIV.style.right = 'auto';
		}
		else {
			right = rSide;
			PVI.PrevDIV.style.left = 'auto';
		}

		if (PVI.xy[1] < bSide) {
			top = PVI.xy[1];
			PVI.PrevDIV.style.bottom = 'auto';
		}
		else {
			bottom = bSide;
			PVI.PrevDIV.style.top = 'auto';
		}

		if (!pre && PVI.target.imagus_cache) {
			var ow = PVI.imageStack[PVI.target.imagus_cache][0], oh = PVI.imageStack[PVI.target.imagus_cache][1], w, h, vAreaFill, hAreaFill, ratio = ow / oh;

			w = ow + PVI.PrevDIV.outsize;
			h = oh + PVI.PrevDIV.outsize;

			if (PVI.cfg['placement'] === 2) {
				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';

				w = Math.min(w, winW);
				h = Math.min(h, winH);

				if (w / h > ow / oh) { w = ratio * h; }
				else { h = w / ratio; }

				left = (winW - w) / 2;
				top = (winH - h) / 2;
				right = bottom = undefined;
			}
			else {
				w = Math.min(w, winW);
				h = Math.min(h, winH);

				if (top) { hAreaFill = bSide; }
				else { hAreaFill = PVI.xy[1]; }

				hAreaFill = ratio > winW / hAreaFill ? winW : hAreaFill * ratio;

				if (left) { vAreaFill = rSide; }
				else { vAreaFill = PVI.xy[0]; }

				vAreaFill = ratio > vAreaFill / winH ? vAreaFill : winH * ratio;

				if (left && top) {
					/*PVI.PrevDIV.style.top = PVI.PrevDIV.style.left = 'auto';
					top = left = undefined; bottom = right = 0;*/
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, bSide);
						if (PVI.cfg['placement'] === 1) { left = Math.max(0, PVI.xy[0] - ratio * h / 2); }
						else { left -= Math.max(0, w - rSide); }
					}
					else {
						w = Math.min(w, rSide);
						if (PVI.cfg['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / ratio / 2); }
						else { top -= Math.max(0, h - bSide); }
					}
				}

				if (right && top) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, bSide);
						if (PVI.cfg['placement'] === 1) { right = Math.max(0, rSide - ratio * h / 2); }
						else { right -= Math.max(0, w - PVI.xy[0]); }
					}
					else {
						w = Math.min(w, PVI.xy[0]);
						if (PVI.cfg['placement'] === 1) { top = Math.max(0, PVI.xy[1] - w / ratio / 2); }
						else { top -= Math.max(0, h - bSide); }
					}
				}

				if (left && bottom) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, PVI.xy[1]);
						if (PVI.cfg['placement'] === 1) { left = Math.max(0, PVI.xy[0] - ratio * h / 2); }
						else { left -= Math.max(0, w - rSide); }
					}
					else {
						w = Math.min(w, rSide);
						if (PVI.cfg['placement'] === 1) { bottom = Math.max(0, bSide - w / ratio / 2); }
						else { bottom -= Math.max(0, h - PVI.xy[1]); }
					}
				}

				if (right && bottom) {
					if (hAreaFill > vAreaFill) {
						h = Math.min(h, PVI.xy[1]);
						if (PVI.cfg['placement'] === 1) { right = Math.max(0, rSide - ratio * h / 2); }
						else { right -= Math.max(0, w - PVI.xy[0]); }
					}
					else {
						w = Math.min(w, PVI.xy[0]);
						if (PVI.cfg['placement'] === 1) { bottom = Math.max(0, bSide - w / ratio / 2); }
						else { bottom -= Math.max(0, h - PVI.xy[1]); }
					}
				}
			}
		}

		top === undefined || (PVI.PrevDIV.style.top = (top + PVI.cfg['margin']) + 'px');
		left === undefined || (PVI.PrevDIV.style.left = (left + PVI.cfg['margin']) + 'px');
		bottom === undefined || (PVI.PrevDIV.style.bottom = (bottom + PVI.cfg['margin']) + 'px');
		right === undefined || (PVI.PrevDIV.style.right = (right + PVI.cfg['margin']) + 'px');

		if (!pre && PVI.target.imagus_cache) {
			if (PVI.target.imagus_SVG) {
				if (w / h > ow / oh) { w = ratio * h; }
				else { h = w / ratio; }

				PVI.PrevOBJ.style.width = (w - PVI.PrevDIV.outsize) + 'px';
				PVI.PrevOBJ.style.height = (h - PVI.PrevDIV.outsize) + 'px';
			}

			PVI.PrevOBJ.style.maxWidth = (w - PVI.PrevDIV.outsize) + 'px';
			PVI.PrevOBJ.style.maxHeight = (h - PVI.PrevDIV.outsize) + 'px';

			PVI.cfg['caption'] && (PVI.PrevDIV.lastChild.innerText = PVI.target.imagus_title || '');// + ' ' + PVI.PrevOBJ.clientWidth + 'x' + PVI.PrevOBJ.clientHeight;
		}
	},
	hide: function (ev) {
		ev.event && (ev = ev.event);
		PVI.collectxy = false;

		if (PVI.iFrame) {
			if (typeof ev.fromElement.imagus_cache == 'string') {
				oex.postMessage({'cmd': 'from_frame', 'hide': true});
			}
		}
		else if (!PVI.fullZoom) {
			win.removeEventListener('mousemove', PVI.m_move, false);
		}

		PVI.cfg['outline'] && ((ev.target.origOutline === undefined) || (ev.target.style.outline = ev.target.origOutline));

		clearInterval(PVI.timers.preview);
		clearInterval(PVI.timers.imload);

		if (PVI.fullZoom || (PVI.cfg['deactivate'] && ev[PVI.cfg['actTrigger'] + 'Key'])) { return; }

		win.removeEventListener('mouseout', PVI.hide, false);

		if (!PVI.hiding && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
			if (PVI.PrevDIV.childElementCount > 1) {
				if (PVI.PrevDIV.lastChild.nodeName == 'OBJECT') {
					PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild);
				}
				else if (PVI.cfg['caption']) {
					PVI.PrevDIV.lastChild.innerText = '';
				}
			}

			PVI.hiding = true;
			var onlypos = !PVI.cfg['sizing'] && !PVI.cfg['fade'];

			if (onlypos || (PVI.cfg['position'] && PVI.cfg['follow'])) {
				if (onlypos) {
					var winW = Math.max(doc.body.clientWidth, root.clientWidth);
					(winW > win.innerWidth) && (winW = win.innerWidth);
				}

				if (!onlypos) {
					if (PVI.PrevDIV.style.top != 'auto') {
						PVI.PrevDIV.style.top = ev.clientY + 'px';
					}
					else if (PVI.PrevDIV.style.bottom != 'auto') {
						PVI.PrevDIV.style.bottom = (win.innerHeight - ev.clientY) + 'px';
					}
				}

				if (PVI.PrevDIV.style.right != 'auto') {
					PVI.PrevDIV.style.right = (onlypos ? - ev.clientX - 30: doc.body.clientWidth - ev.clientX) + 'px';
				}
				else if (PVI.PrevDIV.style.left != 'auto') {
					PVI.PrevDIV.style.left = (onlypos ? - winW + ev.clientX - 30 : ev.clientX) + 'px';
				}
			}

			if (PVI.cfg['sizing']) {
				PVI.PrevOBJ.style.maxWidth = '0px';
				PVI.PrevOBJ.style.maxHeight = '0px';
			}

			PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '0');
			onlypos && !PVI.cfg['position'] && PVI.reset();
		}
	},
	set: function (src) {
		clearInterval(PVI.timers.imload);
		PVI.create();

		if (PVI.target.imagus_SVG || rgxIsSVG.test(src)) {
			PVI.target.imagus_SVG || (PVI.target.imagus_SVG = true);
			PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '';
			PVI.PrevOBJ.innerText = 'Loddig SVG...';

			if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName == 'OBJECT') {
				PVI.PrevDIV.lastChild.data = src + '#IMAGUS_SVG_GET';
			}
			else {
				var svg_obj = doc.createElement('OBJECT');
				svg_obj.style.cssText = 'width:0;height:0';
				svg_obj.data = src + '#IMAGUS_SVG_GET';
				PVI.PrevDIV.appendChild(svg_obj);
			}

			clearInterval(PVI.timers.imload);
			PVI.timers.imload = setTimeout(function () {
				PVI.PrevOBJ.innerText = 'Timmo!';

				if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName == 'OBJECT') {
					svg_obj.date = '';
					PVI.PrevDIV.removeChild(svg_obj);
				}
			}, PVI.cfg['timeout']);
			PVI.show();
			return;
		}

		PVI.img = new Image();
		PVI.img.onerror = function (x) {
			clearInterval(PVI.timers.imload);

			//if (x !== true) { PVI.target.imagus_cache = true; }

			//this.src = '';
			PVI.PrevOBJ.innerText = (x === true ? 'Timmo!' : 'Erray!');
			throw null;
		};

		PVI.img.src = src;

		if (PVI.img.naturalWidth) {
			if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - PVI.cfg['zoomResized'] < PVI.target.width && PVI.img.naturalHeight - PVI.cfg['zoomResized'] < PVI.target.clientHeight)) {
				delete PVI.target.imagus_thumb;
				PVI.target.imagus_cache = true;
				PVI.cfg['outline'] && (PVI.target.style.outline = '1px solid purple');
				return;
			}

			PVI.PrevOBJ.data = PVI.target.imagus_cache = src;
			PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
			PVI.show();
			return;
		}

		PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '';
		PVI.PrevOBJ.innerText = 'Loddig...';
		PVI.show();

		var startTime = Date.now();

		PVI.timers.imload = setInterval(function () {
			if (PVI.img.naturalWidth && PVI.img.naturalHeight) {
				clearInterval(PVI.timers.imload);

				if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - PVI.cfg['zoomResized'] < PVI.target.width && PVI.img.naturalHeight - PVI.cfg['zoomResized'] < PVI.target.clientHeight)) {
					PVI.PrevOBJ.innerText = 'Nopee...'; //PVI.PrevDIV.style.display = 'none';
					delete PVI.target.imagus_thumb;
					PVI.target.imagus_cache = true;
					PVI.cfg['outline'] && (PVI.target.style.outline = '1px solid purple');
					return;
				}

				PVI.PrevOBJ.data = PVI.target.imagus_cache = src;
				PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
				PVI.show();
				return;
			}

			if (Date.now() - startTime > PVI.cfg['timeout']) {
				PVI.img.onerror(true);
			}
		}, PVI.cfg['checkInterval']);
	},
	reset: function () {
		PVI.PrevDIV.style.display = 'none';

		if (PVI.cfg['sizing']) {
			PVI.PrevOBJ.style.maxWidth = '0px';
			PVI.PrevOBJ.style.maxHeight = '0px';
		}

		if (PVI.PrevOBJ.style.width != 'auto') {
			PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
		}

		PVI.PrevDIV.style.top = PVI.PrevDIV.style.bottom = PVI.PrevDIV.style.right = PVI.PrevDIV.style.left = 'auto';
		PVI.cfg['fade'] && (PVI.PrevDIV.style.opacity = '0');
		delete PVI.PrevOBJ.data;
		PVI.PrevOBJ.innerText = '';
		PVI.cfg['caption'] && (PVI.PrevDIV.lastChild.innerText = '');
		PVI.hiding = false;

		if (PVI.fullZoom) {
			PVI.fullZoom = false;
			PVI.PrevDIV.style['OTransition'] = PVI.anim.container;
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj;
			PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
		}

		win.removeEventListener('keydown', PVI.key_action, false);
	},
	key_action: function (ev) {
		if (PVI.target && PVI.PrevDIV.style.display == 'block') {
			if (ev.keyCode === 79 && typeof PVI.target.imagus_cache == 'string') {
				oex.postMessage({'cmd': 'open', 'url': PVI.PrevOBJ.data.replace(rgxHash, ''), nf: ev.shiftKey});
			}
			else if (ev.keyCode === 67) { PVI.PrevDIV.lastChild.style.whiteSpace = PVI.PrevDIV.lastChild.style.whiteSpace == 'nowrap' ? 'normal' : 'nowrap'; }
			else if (ev.keyCode === 90 || ev.keyCode === 13) {
				ev.preventDefault();
				if (PVI.fullZoom) {
					PVI.reset();
					!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move, false);
					return;
				}

				var
					w = PVI.imageStack[PVI.target.imagus_cache][0] + PVI.PrevDIV.outsize - PVI.cfg['margin'] * 2,
					h = PVI.imageStack[PVI.target.imagus_cache][1] + PVI.PrevDIV.outsize - PVI.cfg['margin'] * 2,
					ratio = w / h,
					winW = Math.max(doc.body.clientWidth, root.clientWidth),
					winH = PVI.helper_div.clientHeight;

				(winW > win.innerWidth) && (winW = win.innerWidth);

				PVI.PrevDIV.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = 'none';
				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';
				PVI.PrevDIV.style.left = parseInt((winW - w) / 2, 10) + 'px';
				PVI.PrevDIV.style.top = parseInt((winH - h) / 2, 10) + 'px';

				PVI.fullZoom = true;
				!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move, false);
				win.removeEventListener('mouseout', PVI.hide, false);
			}
		}
	},
	m_over: function (ev) {
		if (ev.event.target.imagus_cache === true || PVI.fullZoom || (!PVI.cfg['deactivate'] && PVI.cfg['actTrigger'] && !ev.event[PVI.cfg['actTrigger'] + 'Key']) ||
				(PVI.cfg['deactivate'] && (!PVI.cfg['actTrigger'] || ev.event[PVI.cfg['actTrigger'] + 'Key']))) { return; }

		PVI.target = ev.event.target;
		var imgsrc, cache = (PVI.target.imagus_cache && !PVI.target.imagus_sieve_cache);

		if (!PVI.target.imagus_sieve_cache && typeof PVI.target.imagus_cache_resolved == 'string') {
			imgsrc = PVI.target.imagus_cache_resolved;
			cache = false;
		}

		if (cache || (imgsrc = imgsrc || PVI.find()) || imgsrc === null) {
			if (imgsrc && !PVI.target.imagus_cache_resolved) {
				if (PVI.cfg['preload'] && PVI.cfg['hoverTime'] > 100 && !PVI.imageStack[imgsrc]) {
					new Image().src = imgsrc;
					PVI.imageStack[imgsrc] = true;
				}

				PVI.target.imagus_cache_resolved = imgsrc;
			}

			PVI.collectxy = true;

			if (PVI.cfg['outline']) {
				(typeof PVI.target.origOutline == 'string') || (PVI.target.origOutline = PVI.target.style.outline);
				PVI.target.style.outline = '1px solid ' + (PVI.target.imagus_SVG ? 'blue' : 'red');
			}

			win.addEventListener('mouseout', PVI.hide, false);
			!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move, false);

			PVI.timers.preview = setTimeout(function () {
				win.addEventListener('keydown', PVI.key_action, false);
				PVI.cfg['hideOnScroll'] && doc.addEventListener('scroll', PVI.hideOnScrollFunc, false);

				PVI.cfg['outline'] && (PVI.target.style.outline = '0');
				(PVI.target.imagus_cache_resolved === true) || (PVI.target.imagus_cache_resolved = true);

				if (imgsrc === null) {
					PVI.create();
					PVI.PrevOBJ.innerText = 'Resova...';
					PVI.show();
					return;
				}

				if (cache || PVI.imageStack[imgsrc] instanceof Array) {
					PVI.create();
					delete PVI.PrevOBJ.data;
					PVI.PrevOBJ.data = cache ? PVI.target.imagus_cache : (PVI.target.imagus_cache = imgsrc);
					PVI.show();
					return;
				}

				PVI.set(imgsrc);
			}, PVI.hiding ? (PVI.cfg['waitHide'] ? Math.max(PVI.cfg['fade'], PVI.cfg['sizing'], PVI.cfg['position']) + 100 : 0) : PVI.cfg['hoverTime']);
		}
		else {
			PVI.target.imagus_cache = true;
		}
	},
	m_move: function (ev) {
		if (PVI.fullZoom) {
			var xy,
				w = PVI.imageStack[PVI.target.imagus_cache][0] + PVI.PrevDIV.outsize - PVI.cfg['margin'] * 2,
				h = PVI.imageStack[PVI.target.imagus_cache][1] + PVI.PrevDIV.outsize - PVI.cfg['margin'] * 2,
				ratio = w / h,
				winW = Math.max(doc.body.clientWidth, root.clientWidth),
				winH = PVI.helper_div.clientHeight;

			(winW > win.innerWidth) && (winW = win.innerWidth);
			//winH = win.innerHeight - ( winW < Math.max(doc.body.scrollWidth, root.scrollWidth) ? win.innerWidth - winW : 0);

			if (w > winW) {
				xy = ev.clientX * (w - winW + 100) / winW;
				PVI.PrevDIV.style.left = (-xy + 50) + 'px';
			}
			else {
				PVI.PrevDIV.style.left = ((winW - w) / 2) + 'px';
			}

			if (h > winH) {
				xy = ev.clientY * (h - winH + 100) / winH;
				PVI.PrevDIV.style.top = (-xy + 50) + 'px';
			}
			else {
				PVI.PrevDIV.style.top = ((winH - h) / 2) + 'px';
			}

			return;
		}

		if (PVI.collectxy/* && (!PVI.cfg['deactivate'] && ev[PVI.cfg['actTrigger'] + 'Key'])*/) {
			PVI.xy[0] = ev.clientX;
			PVI.xy[1] = ev.clientY;

			if ((!PVI.cfg['deactivate'] && PVI.cfg['actTrigger'] && !ev[PVI.cfg['actTrigger'] + 'Key']) ||
				(PVI.cfg['deactivate'] && (!PVI.cfg['actTrigger'] || ev[PVI.cfg['actTrigger'] + 'Key']))) { return; }
			else if (PVI.cfg['placement'] < 2 && !PVI.hiding && PVI.cfg['move'] && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
				PVI.show();
			}
		}
	},
	hideOnScrollFunc: function () {
		//if (PVI.fullZoom) { return; }
		!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move, false);
		PVI.reset();
		doc.removeEventListener('scroll', PVI.hideOnScrollFunc, false);
	},
	onMessage: function (e) {
		if (e.data['hello']) { return; }
		PVI.create();

		if (e.data['cmd'] == 'resolved') {
			if (!e.data['m']) {
				PVI.PrevOBJ.innerText = 'Faila...';
			}
			else {
				if (PVI.target.src && PVI.target.src == e.data['m']) {
					PVI.target.imagus_cache = true;
					PVI.PrevOBJ.innerText = 'Nopee...';
					return;
				}

				if (PVI.resolving.nodes[e.data.id] === PVI.target) {
					PVI.set(e.data['m']);
					PVI.target.imagus_cache_resolved = true;
				}
				else {
					/*if (PVI.cfg['preload'] && PVI.cfg['hoverTime'] > 100 && !PVI.imageStack[e.data.m]) {
						new Image().src = e.data.m;
						PVI.imageStack[e.data.m] = true;
					}*/

					PVI.resolving.nodes[e.data.id].imagus_cache_resolved = e.data['m'];
				}
			}
		}
		else if (e.data['cmd'] == 'svg_info') {
			var url = e.data['url'].replace('#IMAGUS_SVG_GET', '#IMAGUS_SVG');

			if (!e.data['svg']) {
				PVI.PrevOBJ.innerText = 'Erray! no SVG...';
				return;
			}

			if (!PVI.imageStack[url]) {
				var w = e.data['wh']['w'], h = e.data['wh']['h'];

				if (PVI.cfg['svgsale'] === 1) {
					h = 400 / (w / h);
					w = 400;
				}
				else if (PVI.cfg['svgsale'] === 2) {
					h = (win.innerWidth / 2) / (w / h);
					w = win.innerWidth / 2;
				}
				else if (PVI.cfg['svgsale'] === 4) {
					h = win.screen.width / (w / h);
					w = win.screen.width;
				}

				PVI.imageStack[url] = [w, h];
			}

			if (PVI.PrevDIV.childElementCount > 1 && PVI.PrevDIV.lastChild.nodeName == 'OBJECT') { PVI.PrevDIV.lastChild.data = ''; PVI.PrevDIV.removeChild(PVI.PrevDIV.lastChild); }
			clearInterval(PVI.timers.imload);

			PVI.PrevOBJ.innerText = '';
			PVI.PrevOBJ.data = PVI.target.imagus_cache = url;
			PVI.show();
		}
		else if (e.data['cmd'] == 'from_frame') {
			PVI.target = PVI.helper_div;

			if (e.data['hide']) {
				PVI.hide({'target': PVI.target, clientX: PVI.PrevDIV.clientWidth / 2, clientY: PVI.PrevDIV.clientHeight / 2});
				return;
			}

			PVI.xy = [0, 0];
			if (PVI.imageStack[e.data['img']]) { PVI.PrevOBJ.data = e.data['img']; PVI.show(); }
			else { PVI.set(e.data['img']); }
		}
		else if (e.data['cmd'] == 'reinit') {
			PVI.init(true);
			PVI.cfg = e.data['prefs']['hz'];
			PVI.init();
		}
	},
	init: function (deinit) {
		if (deinit && PVI.PrevDIV) {
			PVI.PrevDIV && root.removeChild(PVI.PrevDIV);
			PVI.PrevDIV = null;
			PVI.helper_div && root.removeChild(PVI.helper_div);
			PVI.helper_div = null;
			oex.removeEventListener('message', PVI.onMessage, false);
		}
		else {
			PVI.iFrame = window != window.top;
			oex.addEventListener('message', PVI.onMessage, false);
		}

		win.opera[(deinit ? 'remove' : 'add') + 'EventListener']('BeforeEvent.mouseover', PVI.m_over, false);
	},
	after_init: function (e) {
		if (e.data['hello']) {
			PVI.cfg = e.data['prefs']['hz'];
			PVI.sieve = e.data['prefs']['sieve'];
			oex.removeEventListener('message', PVI.after_init, false);
		}
	}
};

if (!isRaster) {
	PVI.init();

	oex.addEventListener('message', PVI.after_init, false);
}

oex.postMessage({'cmd': 'hello'});

})(window, document);